﻿local agony, corruption, ua 		= 0, 0, 0;
local mastery, haste, crit, spd 	= 0, 0, 0, 0;
local agony_targets 				= {};
local corruption_targets 			= {};
local ua_targets 					= {};
local target_id 					= 0;
local timer 						= 0;
local me 							= 0;

local agony_name					= GetSpellInfo(980);
local corruption_name				= GetSpellInfo(172);
local ua_name						= GetSpellInfo(30108);

local event_type,source_GUID,dest_GUID,spell;

AffDotsFrame:SetMovable(true);
AffDotsFrame:EnableMouse(true);
AffDotsFrame:SetUserPlaced(true);
AffDotsFrame:SetScript("OnMouseDown", function(self, button)
  if button == "LeftButton" and not self.isMoving then
   self:StartMoving();
   self.isMoving = true;
  end
end)
AffDotsFrame:SetScript("OnMouseUp", function(self, button)
  if button == "LeftButton" and self.isMoving then
   self:StopMovingOrSizing();
   self.isMoving = false;
  end
end)
AffDotsFrame:SetScript("OnHide", function(self)
  if ( self.isMoving ) then
   self:StopMovingOrSizing();
   self.isMoving = false;
  end
end)

local AgonyCooldown = CreateFrame("Cooldown", "AgonyCD", AgonyFrame);
AgonyCooldown:SetAllPoints(AgonyIcon);
local CorruptionCooldown = CreateFrame("Cooldown", "CorruptionCD", CorruptionFrame);
CorruptionCooldown:SetAllPoints(CorruptionIcon);
local UACooldown = CreateFrame("Cooldown", "UACD", UAFrame);
UACooldown:SetAllPoints(UAIcon);

AgonyFrame.texture = AgonyFrame:CreateTexture();
AgonyFrame.texture:SetAllPoints(AgonyFrame);
CorruptionFrame.texture = CorruptionFrame:CreateTexture();
CorruptionFrame.texture:SetAllPoints(CorruptionFrame);
UAFrame.texture = UAFrame:CreateTexture();
UAFrame.texture:SetAllPoints(UAFrame);

local function AffDotsRound(num)
	return math.floor(num+.5)
end

local function AffDotsGetDotDmg()
	local damage_bonus = ((100+crit)/100)*((100+mastery)/100);
	local haste_bonus = 2/(1+(haste/100));
	local agony_ticks = AffDotsRound(24/haste_bonus);
	local corruption_ticks = AffDotsRound(18/haste_bonus);
	local ua_ticks = AffDotsRound(14/haste_bonus);
	agony = AffDotsRound((agony_ticks*(280+spd*0.26)*damage_bonus)/1000);
	corruption = AffDotsRound(((1926+corruption_ticks*spd*0.2)*damage_bonus)/1000);
	ua = AffDotsRound(((1792+ua_ticks*spd*0.24)*damage_bonus)/1000);
	
	AgonyPower:SetText(agony);
	CorruptionPower:SetText(corruption);
	UAPower:SetText(ua);
end

local function AffDotsSetFrames()
	local time_now = GetTime();
	local duration_left;
	local _,_,_,_,_,agony_duration,agony_expires = UnitDebuff("target", agony_name,"","player");
	local _,_,_,_,_,corruption_duration,corruption_expires = UnitDebuff("target", corruption_name,"","player");
	local _,_,_,_,_,ua_duration,ua_expires = UnitDebuff("target", ua_name,"","player");
	
	if(agony_expires ~= nil and agony_targets[tostring(target_id)]~= nil) then
		duration_left = agony_expires - time_now;
		AgonyCooldown:SetCooldown(time_now-agony_duration+duration_left, agony_duration);
		
		if(agony_targets[tostring(target_id)]>=agony and duration_left>12) then
			AgonyFrame.texture:SetTexture(0.5,0,0,0.5);
		elseif(agony_targets[tostring(target_id)]>=agony) then
			AgonyFrame.texture:SetTexture(0.5,0.5,0,0.5);
		elseif(agony_targets[tostring(target_id)]<agony and duration_left>12) then
			AgonyFrame.texture:SetTexture(0,0,0.5,0.5);
		else
			AgonyFrame.texture:SetTexture(0,0.5,0,0.5);
		end
		AgonyCooldown:Show();
	else
		AgonyCooldown:Hide();
		AgonyFrame.texture:SetTexture(0,0,0,0.5);
	end
	
	if(corruption_expires ~= nil and corruption_targets[tostring(target_id)]~= nil) then
		duration_left = corruption_expires - time_now;
		CorruptionCooldown:SetCooldown(time_now-corruption_duration+duration_left, corruption_duration);			
		if(corruption_targets[tostring(target_id)]>=corruption and duration_left>9) then
			CorruptionFrame.texture:SetTexture(0.5,0,0,0.5);
		elseif(corruption_targets[tostring(target_id)]>=corruption) then
			CorruptionFrame.texture:SetTexture(0.5,0.5,0,0.5);
		elseif(corruption_targets[tostring(target_id)]<corruption and duration_left>9) then
			CorruptionFrame.texture:SetTexture(0,0,0.5,0.5);
		else
			CorruptionFrame.texture:SetTexture(0,0.5,0,0.5);
		end
		CorruptionCooldown:Show();
	else
		CorruptionCooldown:Hide();
		CorruptionFrame.texture:SetTexture(0,0,0,0.5);
	end
	
	if(ua_expires ~= nil and ua_targets[tostring(target_id)]~= nil) then
		duration_left = ua_expires - time_now;
		UACooldown:SetCooldown(time_now-ua_duration+duration_left, ua_duration);
		if(ua_targets[tostring(target_id)]>=ua and duration_left>7) then
			UAFrame.texture:SetTexture(0.5,0,0,0.5);
		elseif(ua_targets[tostring(target_id)]>=ua) then
			UAFrame.texture:SetTexture(0.5,0.5,0,0.5);
		elseif(ua_targets[tostring(target_id)]<ua and duration_left>7) then
			UAFrame.texture:SetTexture(0,0,0.5,0.5);
		else
			UAFrame.texture:SetTexture(0,0.5,0,0.5);
		end
		UACooldown:Show();
	else
		UACooldown:Hide();
		UAFrame.texture:SetTexture(0,0,0,0.5);
	end
end

local function AffDotsGetRatings()
	local mas = GetMastery()*3.1;
	local has = GetRangedHaste();
	local cri = GetSpellCritChance(6);
	local dmg = GetSpellBonusDamage(6);
	if( mas ~= mastery or has ~= haste or cri ~= crit or dmg ~= spd) then
		mastery = mas;
		haste 	= has;
		crit 	= cri;
		spd 	= dmg;
		AffDotsGetDotDmg();
	end
end

local function AffDotsTargetDots()
	if(target_id ~= nil) then
		AgonyOnTarget:SetText(agony_targets[tostring(target_id)] or 0);
		CorruptionOnTarget:SetText(corruption_targets[tostring(target_id)] or 0);
		UAOnTarget:SetText(ua_targets[tostring(target_id)] or 0);
	end
end

local function AffDotsCleanTargets()
	for k,v in pairs(agony_targets) do agony_targets[k]=nil end
	for k,v in pairs(corruption_targets) do corruption_targets[k]=nil end
	for k,v in pairs(ua_targets) do ua_targets[k]=nil end
	AgonyOnTarget:SetText(0);
	CorruptionOnTarget:SetText(0);
	UAOnTarget:SetText(0);
end

local function onUpdate(self,elapsed)
    timer = timer + elapsed;
    if timer >= 0.2 then
        AffDotsGetRatings();
		AffDotsSetFrames();
		AffDotsTargetDots();
        timer = 0;
    end
end

local function Events()
	if(GetSpecialization()==1) then
		AffDotsFrame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
		AffDotsFrame:RegisterEvent("PLAYER_REGEN_ENABLED");
		AffDotsFrame:RegisterEvent("UNIT_TARGET");
		AffDotsFrame:SetScript("OnUpdate", onUpdate);
		AffDotsFrame:Show();
	else
		AffDotsFrame:SetScript("OnUpdate", nil);
		AffDotsFrame:UnregisterEvent("PLAYER_REGEN_ENABLED");
		AffDotsFrame:UnregisterEvent("UNIT_TARGET");
		AffDotsFrame:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
		AffDotsFrame:Hide();
	end
end

function OnEvent(frame, event, ...)
	if event == "COMBAT_LOG_EVENT_UNFILTERED" then
		_,event_type,_,source_GUID,_,_,_,dest_GUID,_,_,_,spell = select(1, ...);
		if(source_GUID == me and dest_GUID ~= me) then
			if(event_type == "SPELL_DAMAGE" and spell == 77799) then
				corruption_targets[tostring(dest_GUID)] = corruption;
				ua_targets[tostring(dest_GUID)] = ua;
			elseif(event_type == "SPELL_AURA_APPLIED" or event_type == "SPELL_AURA_REFRESH") then
				if(spell == 172 or spell == 87389) then
					corruption_targets[tostring(dest_GUID)] = corruption;
				elseif(spell == 980) then
					agony_targets[tostring(dest_GUID)] = agony;
				elseif(spell == 30108) then
					ua_targets[tostring(dest_GUID)] = ua;
				end
			elseif(event_type == "SPELL_AURA_REMOVED") then
				if(spell == 172 or spell == 87389) then
					corruption_targets[tostring(dest_GUID)]=nil;
				elseif(spell == 980) then
					agony_targets[tostring(dest_GUID)]=nil;
				elseif(spell == 30108) then
					ua_targets[tostring(dest_GUID)]=nil;
				end
			end
		end
	elseif event == "PLAYER_REGEN_ENABLED" then
		AffDotsCleanTargets();
	elseif event == "UNIT_TARGET" then
		target_id = UnitGUID("target");
	elseif event == "ACTIVE_TALENT_GROUP_CHANGED" then
		Events();
	elseif(event == "PLAYER_ALIVE" or event == "PLAYER_ENTERING_WORLD") then
		me = UnitGUID("player");
		Events();
	end
end